<template>
    <v-row>
        <v-col>
            <v-card>
                <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                    <v-container class="px-8">
                        <v-row class="pb-2">
                            <v-col cols="4" md="6" class="align-self-center flex-grow-1 flex-shrink-0">
                                <div class="title text--primary fill-height">
                                    {{ $t(mode + '_', [$t('plan')]) }}
                                </div>
                            </v-col>

                            <v-spacer></v-spacer>

                            <v-col class="flex-grow-0 flex-shrink-1">
                                <v-switch class="toggle"
                                          @change="onStatusChange"
                                          v-model="localValue.enabled"
                                          :loading="loading"
                                          :label="$t('enabled')"
                                          :true-value="1"
                                          :false-value="0"
                                          inset
                                          hide-details
                                >
                                </v-switch>
                            </v-col>

                            <v-col class="flex-grow-0 flex-shrink-1">
                                <v-switch class="toggle"
                                          v-model="localValue.featured"
                                          :loading="loading"
                                          :label="$t('featured')"
                                          :true-value="1"
                                          :false-value="0"
                                          inset
                                          hide-details
                                >
                                </v-switch>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('plan_', [$t('info')]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <div class="field-label">{{ $t('name') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="name" rules="required">
                                    <v-text-field
                                        v-model="localValue.name"
                                        :loading="loading"
                                        :error-messages="errors"
                                        :placeholder="$t('plan_', [$t('name')])"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>

                            <v-col cols="12">
                                <div class="field-label">{{ $t('info') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="info" rules="required">
                                    <text-editor
                                        v-model="localValue.info"
                                        :errors="errors"
                                    >
                                    </text-editor>
                                </ValidationProvider>
                            </v-col>

                            <v-col cols="12">
                                <div class="field-label">{{ $t('description') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="description" rules="required">
                                    <text-editor
                                        v-model="localValue.description"
                                        :errors="errors"
                                    >
                                    </text-editor>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('plan_', [$t('pricing')]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col>
                                <div class="field-label">{{ $t('interval') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="interval" rules="required">
                                    <v-select
                                        v-model="localValue.interval"
                                        :items="intervals"
                                        :disabled="isEditMode"
                                        :error-messages="errors"
                                        outlined
                                    ></v-select>
                                </ValidationProvider>
                            </v-col>
                            <v-col>
                                <div class="field-label">{{ $t('amount') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="amount" rules="required|min_value:1|decimal">
                                    <v-text-field
                                        v-model="localValue.amount"
                                        :loading="loading"
                                        :suffix="$t('per_' + localValue.interval)"
                                        :error-messages="errors"
                                        :placeholder="$t('plan_', [$t('amount')])"
                                        :disabled="isEditMode"
                                        prefix="MYR"
                                        type="number"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                            <v-col>
                                <div class="field-label">{{ $t('purchase_amount') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="purchase_amount" rules="required">
                                    <v-text-field
                                        v-model="localValue.purchase_amount"
                                        :loading="loading"
                                        :error-messages="errors"
                                        :placeholder="$t('plan_', [$t('amount')])"
                                        :hint="$t('purchase_amount_hint')"
                                        prefix="MYR"
                                        type="number"
                                        outlined
                                        persistent-hint
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('plan_', [$t('exchange_limit')]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col>
                                <div class="field-label">{{ $t('exchange_limit') }}</div>
                                <v-slider
                                    v-model="localValue.exchange_limit"
                                    :loading="loading"
                                    :hint="$t('exchange_limit_hint')"
                                    class="slider"
                                    thumb-color="primary"
                                    thumb-label="always"
                                    persistent-hint
                                    :min="0"
                                    :max="10"
                                    step="1"
                                >
                                </v-slider>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col class="d-flex align-center flex-grow-0 flex-shrink-1">
                                <div class="subtitle-1 text--secondary max-content">
                                    {{ $t('plan_', [$tc('policy', 2)]) }}
                                </div>
                            </v-col>
                            <v-col cols="2">
                                <v-btn
                                    @click="addPolicy"
                                    class="primary"
                                    block
                                >
                                    <v-icon left color="white">mdi-plus</v-icon>
                                    {{ $tc('policy', 1) }}
                                </v-btn>
                            </v-col>
                        </v-row>

                        <v-row>
                            <v-col class="py-3">
                            <v-alert
                                text
                                outlined
                                color="deep-orange"
                                icon="mdi-alert"
                            >
                                {{$t('collection_option_desc')}}
                            </v-alert>
                            </v-col>
                        </v-row>

                        <v-row
                            class="ml-2"
                            v-for="(policy, index) in localValue.policies"
                            :key="policy.id || policy.nonce"
                        >
                            <div class="col flex-grow-0 align-self-center">
                                <v-btn
                                    @click="removePolicy(policy.id || policy.nonce)"
                                    class="error"
                                    icon
                                >
                                    <v-icon color="white">mdi-minus</v-icon>
                                </v-btn>
                            </div>
                            <v-col>
                                <div class="field-label">{{ $t('product_', [$tc('collection', 1)]) }}</div>
                                <ValidationProvider
                                    :name="$tc('type', 1)"
                                    :vid="`policies.${index}.threshold`"
                                    v-slot="{ errors }"
                                    rules="required"
                                >
                                    <policy-rule
                                        v-model="policy.rules"
                                        :items="types"
                                        :errors="errors"
                                        :multiple="true"
                                        hide-details="auto"
                                    ></policy-rule>
                                </ValidationProvider>
                            </v-col>

                            <v-col>
                                <div class="field-label">{{ $t('logical') }}</div>
                                <v-select
                                    v-model="policy.logical"
                                    :items="logicals"
                                    outlined
                                    hide-details
                                >
                                </v-select>
                            </v-col>

                            <v-col class="flex-grow-0 flex-shrink-1">
                                <div class="field-label">{{ $t('quantity') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="quantity" rules="required|min_value:1">
                                    <v-text-field
                                        v-model="policy.quantity"
                                        :loading="loading"
                                        :error-messages="errors"
                                        type="number"
                                        hide-details="auto"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('plan_', [$t('reminder')]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <v-checkbox
                                    v-model="localValue.sms"
                                    class="mt-0"
                                    :label="$t('reminder_desc')"
                                    hide-details
                                ></v-checkbox>
                            </v-col>
                        </v-row>

                        <v-divider class="mt-3"></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('plan_', [$tc('charge', 2)]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12">
                                <v-checkbox
                                    v-model="showCharges"
                                    class="mt-0"
                                    :label="$t('charge_desc')"
                                    hide-details
                                ></v-checkbox>
                            </v-col>
                        </v-row>

                        <v-row
                            class="ml-2"
                            v-for="(surcharge, index) in localValue.surcharges"
                            :key="surcharge.threshold || surcharge.nonce"
                        >
                            <div class="col flex-grow-0 align-self-center">
                                <v-btn
                                    @click="removeCharge(surcharge.id || surcharge.nonce)"
                                    class="error"
                                    icon
                                >
                                    <v-icon color="white">mdi-minus</v-icon>
                                </v-btn>
                            </div>

                            <v-col>
                                <div class="field-label">{{ $t('threshold') }}</div>
                                <ValidationProvider
                                    name="threshold"
                                    :vid="`surcharges.${index}.threshold`"
                                    v-slot="{ errors }"
                                    :rules="thresholdRule"
                                >
                                    <v-text-field
                                        v-model="surcharge.threshold"
                                        :placeholder="$t('threshold')"
                                        :error-messages="errors"
                                        type="number"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>

                            <v-col>
                                <div class="field-label">{{ $tc('charge', 1) }}</div>
                                <ValidationProvider v-slot="{ errors }" name="charge" rules="min_value:0">
                                    <v-text-field
                                        v-model="surcharge.charge"
                                        :placeholder="$tc('charge', 1)"
                                        :error-messages="errors"
                                        type="number"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row
                            class="ml-2"
                            v-if="showCharges"
                        >
                            <div class="col flex-grow-0 align-self-center">
                                <v-btn
                                    @click="addCharge"
                                    class="primary"
                                    icon
                                >
                                    <v-icon color="white">mdi-plus</v-icon>
                                </v-btn>
                            </div>
                            <v-col>
                                <div class="field-label">{{ $t('threshold') }}</div>
                                <v-text-field
                                    v-model="threshold"
                                    :placeholder="$t('threshold')"
                                    type="number"
                                    outlined
                                >
                                </v-text-field>
                            </v-col>
                            <v-col>
                                <div class="field-label">{{ $tc('charge', 1) }}</div>
                                <v-text-field
                                    v-model="charge"
                                    :placeholder="$tc('charge', 1)"
                                    type="number"
                                    outlined
                                >
                                </v-text-field>
                            </v-col>
                        </v-row>

                        <v-row class="pt-5">
                            <v-col class="text-center">
                                <v-btn
                                    v-if="clearable"
                                    class="text--white mx-2"
                                    color="error"
                                    :loading="submitting"
                                    @click="internalClear"
                                    large
                                >
                                    <v-icon>mdi-close</v-icon>
                                    {{ $t('clear') }}
                                </v-btn>
                                <v-btn
                                    class="text--white mx-2"
                                    color="primary"
                                    :loading="submitting"
                                    @click="internalSave"
                                    large
                                >
                                    <v-icon>mdi-content-save</v-icon>
                                    {{ $t('save') }}
                                </v-btn>
                            </v-col>
                        </v-row>
                    </v-container>
                </ValidationObserver>
            </v-card>
        </v-col>
    </v-row>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import TextEditor from "../editor/TextEditor";
    import {mapMutations} from "vuex";
    import VProductTypeSelect from "../VProductTypeSelect";
    import PolicyRule from "../PolicyRule";

    export default {
        name: "PlanForm",
        components: {
            PolicyRule,
            VProductTypeSelect,
            TextEditor,
            ValidationObserver, ValidationProvider
        },
        props: {
            loading: {
                type: Boolean,
                default: false,
            },
            value: {
                type: Object,
                required: true
            },
            clearable: {
                type: Boolean,
                default: true
            },
            mode: {
                type: String,
                default: 'create',
                validator: value => ['create', 'edit'].indexOf(value) !== -1
            }
        },

        data: () => ({
            submitting: false,
            appliedCharges: false,
            additionalPolicy: false,
            types: [],
            surcharges: [],
            policies: [],
            threshold: 0,
            charge: 0,
            policy: {
                logical: 'none',
                quantity: 1,
                rules: []
            },
            nonce: 1
        }),

        computed: {
            intervals() {
                return [
                    { text: this.$t('day'), value: 'day' },
                    { text: this.$t('week'), value: 'week' },
                    { text: this.$t('month'), value: 'month' },
                    { text: this.$t('year'), value: 'year' }
                ]
            },

            logicals() {
                return [
                    { text: this.$t('logical_none'), value: 'none' },
                    { text: this.$t('logical_or'), value: 'or' },
                    { text: this.$t('logical_and'), value: 'and' }
                ]
            },

            showCharges: {
                get() {
                    return this.appliedCharges || !!this.localValue.surcharges.length;
                },
                set(val) {
                    return this.appliedCharges = val;
                }
            },

            showAdditionalPolicy: {
                get() {
                    return this.additionalPolicy || !!this.localValue.policies.length;
                },
                set(val) {
                    this.additionalPolicy = val;
                }
            },

            thresholdRule() {
                return `gt:${this.localValue.amount}`;
            },

            isEditMode() {
                return this.mode === 'edit';
            },

            localValue: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('input', val);
                }
            }
        },

        created() {
            this.fetchProductTypes();
        },

        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            onStatusChange(status) {
                this.$emit('status', status)
            },

            internalClear() {
                let defaultObject = {
                    name: '',
                    description: '',
                    info: '',
                    amount: 0,
                    exchange_limit: 0,
                    sort: 0,
                    enabled: 1,
                    featured: 0,
                    policies: [],
                    surcharges: [],
                    sms:0
                };

                this.$emit('input', defaultObject);

                this.$refs.observer.reset();
            },

            internalSave() {
                this.submitting = true;

                this.$refs.observer.validate()
                    .then(valid => {
                        if(valid) {
                            this.callApi()
                                .then(data => {
                                    if (data.status === 200) {
                                        this.$router.push('/plans');
                                    }
                                })
                                .catch(data => {
                                    this.error(data.message)
                                    this.$refs.observer.setErrors(data.errors);
                                })
                                .finally(() => {
                                    this.submitting = false;
                                })
                        }
                        else {
                            this.submitting = false;
                        }
                    })
            },

            callApi() {
                if(this.isEditMode) {
                    return new Promise(( resolve, reject ) => {
                        axios.put(`api/plans/${this.localValue.id}`, this.localValue)
                            .then(response => {
                                this.success(this.$t('plan_action.updated'));
                                resolve({
                                    status: response.status,
                                    data: response.data
                                })
                            })
                            .catch(error => {
                                reject(error.response.data)
                            })
                    })
                }
                else {
                    return new Promise(( resolve, reject ) => {
                        axios.post('api/plans', this.localValue)
                            .then(response => {
                                this.success(this.$t('plan_action.created'));
                                resolve({
                                    status: response.status
                                })
                            })
                            .catch(error => {
                                reject(error.response.data)
                            })
                    })
                }
            },

            addCharge() {
                let clone = {
                    nonce: this.nonce++,
                    threshold: this.threshold,
                    charge: this.charge
                };

                this.localValue.surcharges.push(clone);

                this.threshold = 0;
                this.charge = 0;
            },

            removeCharge(id) {
                if(this.isEditMode) {
                    this.$emit('remove-charges', id)
                }
                else {
                    const index = this.surcharges.findIndex(s => s.nonce === id);
                    this.localValue.surcharges.splice(index, 1);
                }
            },

            addPolicy() {
                let clone = {
                    nonce: this.nonce++,
                    ...this.policy
                };

                this.localValue.policies.push(clone);
            },

            removePolicy(id) {
                if(this.isEditMode) {
                    this.$emit('remove-policies', id)
                }
                else {
                    const index = this.policies.findIndex(p => p.nonce === id);
                    this.localValue.policies.splice(index, 1);
                }
            },

            fetchProductTypes() {
                axios.get('api/products/types')
                    .then(({ data }) => {
                        this.types = data.map(d => {
                            d.prime = false
                            return d;
                        });
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
            }
        }
    }
</script>

<style scoped>
    .max-content {
        width: max-content;
    }
</style>
